import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {Invoicing, InvoicingParam} from './model';

/**
 * 分页查询结算
 */
export async function pageInvoicing(params: InvoicingParam) {
  const res = await request.get<ApiResult<PageResult<Invoicing>>>(
    '/tower/tower-invoicing/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同列表
 */
export async function listInvoicing(params?: InvoicingParam) {
  const res = await request.get<ApiResult<Invoicing[]>>(
    '/tower/tower-invoicing',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同
 */
export async function getInvoicing(id: number) {
  const res = await request.get<ApiResult<Invoicing>>(
    '/tower/tower-invoicing/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同
 */
export async function addInvoicing(data: Invoicing) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-invoicing',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同
 */
export async function updateInvoicing(data: Invoicing) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-invoicing',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同
 */
export async function updateBatchInvoicing(data: Invoicing[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-invoicing/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
export async function addBatchInvoicing(data: Invoicing[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-invoicing/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同
 */
export async function removeInvoicing(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-invoicing/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同
 */
export async function removeBatchInvoicing(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-invoicing/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
